unit PagePrincipale;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, XPMan, ExtCtrls, EdtTranslator, EdtURLLabel, StrUtils,
  Registry;

type
  TPrincipale = class(TForm)
    XPManifest: TXPManifest;
    BoutonGenerer: TButton;
    CadreChemins: TGroupBox;
    EditChemin: TEdit;
    AffChemin: TLabel;
    BoutonParcourrir1: TButton;
    EditSortie: TEdit;
    AffSortie: TLabel;
    BoutonParcourrir2: TButton;
    EditNomFichier: TEdit;
    AffNomFichier: TLabel;
    Separateur: TBevel;
    CadreAide: TGroupBox;
    AffAide: TLabel;
    CadreLangue: TGroupBox;
    EdtTranslator: TEdtTranslator;
    ListeLangues: TComboBox;
    CadreAPropos: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    EdtURLLabel1: TEdtURLLabel;
    procedure BoutonGenererClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BoutonParcourrir1Click(Sender: TObject);
    procedure BoutonParcourrir2Click(Sender: TObject);
    procedure ListeLanguesChange(Sender: TObject);
    procedure EditCheminChange(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Principale: TPrincipale;
  Reg: TRegistry;

implementation

uses PageParcourir;

{$R *.dfm}

procedure TPrincipale.BoutonGenererClick(Sender: TObject);
var Resultat: TSearchRec;
    FichierDfm, FichierLng, FichierTmp: TextFile;
    Chemin, Sortie, Ligne, ValeurCaption, ValeurTag, ValeurHint, Code, CodeTemp, Ancien: string;
    Position, Valeur, i: integer;
    PresenceHint: boolean;
begin
if EditChemin.Text[Length(EditChemin.Text) - 1] <> '\' then Chemin := EditChemin.Text + '\' else Chemin := EditChemin.Text;
if EditSortie.Text[Length(EditSortie.Text) - 1] <> '\' then Sortie := EditSortie.Text + '\' + EditNomFichier.Text + '.lng' else Sortie := EditSortie.Text + EditNomFichier.Text + '.lng';
BoutonGenerer.Enabled := False;
CadreChemins.Enabled := False;
AssignFile(FichierLng, Sortie);
try
  Rewrite(FichierLng)
except on EInOutError do
  begin
  MessageBox(Handle, Pchar(EdtTranslator.ReadData(14,0)), Pchar(EdtTranslator.ReadData(14,1)), MB_OK or MB_ICONERROR);
  CadreChemins.Enabled := True;
  BoutonGenerer.Enabled := True;
  exit;
  end;
end;
if FindFirst(Chemin + '*.dfm', faAnyFile, Resultat) = 0 then
  begin
  repeat
  AssignFile(FichierDfm, Chemin + Resultat.Name);
  Reset(FichierDfm);
  Writeln(FichierLng, '[' + Resultat.Name + ']');
  while not eof(FichierDfm) do
    begin
    Readln(FichierDfm, Ligne);
    Ligne := Trim(Ligne);
    // Cas particulier : TStatusBar
    if Pos('TStatusBar', Ligne) <> 0 then
      begin
      i := 1;
      PresenceHint := False;
      while Pos('end>', Ligne) = 0 do
        begin
        Readln(FichierDfm, Ligne);
        Ligne := Trim(Ligne);
        if Pos('Tag', Ligne) <> 0 then
          begin
          Position := Pos('= ', Ligne);
          ValeurTag := Copy(Ligne, Position + 2, Length(Ligne) - Position);
          while Length(ValeurTag) < 4 do ValeurTag := '0' + ValeurTag;
          end;
        if (Pos('Hint', Ligne) <> 0) and (Pos('ShowHint', Ligne) = 0) and (Pos('ParentShowHint', Ligne) = 0) then
          begin
          Position := Pos('''', Ligne) + 1;
          if Ligne <> 'Hint =' then
            ValeurHint := Copy(Ligne, Position, Length(Ligne) - Position)
          else
            begin
            repeat
            Readln(FichierDfm, Ligne);
            ValeurHint := ValeurHint + Trim(Ligne);
            until Ligne[Length(Ligne)] <> '+';
            ValeurHint := StringReplace(ValeurHint, ' +', '', [rfReplaceAll, rfIgnoreCase]);
            ValeurHint := StringReplace(ValeurHint, '''''', '', [rfReplaceAll, rfIgnoreCase]);
            ValeurHint := Copy(ValeurHint, 2, Length(ValeurHint) - 1);
            if ValeurHint[Length(ValeurHint)] = '''' then ValeurHint := Copy(ValeurHint, 1, Length(ValeurHint) - 1) else ValeurHint := ValeurHint + '''';
            end;
          Writeln(FichierLng, '#' + ValeurTag + '-0001 = ' + ValeurHint);
          PresenceHint := True;
          end;
        if Pos('Text', Ligne) <> 0 then
          begin
          Inc(i);
          Position := Pos('''', Ligne) + 1;
          Writeln(FichierLng, '#' + ValeurTag + '-' + Format('%4.4d', [i]) + ' = ' + Copy(Ligne, Position, Length(Ligne) - Position));
          end;
        end;
        ValeurTag := '';
        ValeurHint := '';
      end;
    // Cas particuliers : TComboBox et TListBox
    if (Pos('TComboBox', Ligne) <> 0) or (Pos('TListBox', Ligne) <> 0) then
      begin
      i := -1;
      Readln(FichierDfm, Ligne);
      Ligne := Trim(Ligne);
      if Pos('Tag', Ligne) <> 0 then
        begin
        Position := Pos('= ', Ligne);
        ValeurTag := Copy(Ligne, Position + 2, Length(Ligne) - Position);
        while Length(ValeurTag) < 4 do ValeurTag := '0' + ValeurTag;
        while Pos('Items.Strings = (', Ligne) = 0 do Readln(FichierDfm, Ligne);
        while Pos(''')', Ligne) = 0 do
          begin
          Inc(i);
          Readln(FichierDfm, Ligne);
          Ligne := Trim(Ligne);
          Position := Pos('''', Ligne) + 1;
          if Pos(''')', Ligne) = 0 then ValeurCaption := Copy(Ligne, Position, Length(Ligne) - Position)
          else ValeurCaption := Copy(Ligne, Position, Length(Ligne) - Position - 1);
          Writeln(FichierLng, '#' + ValeurTag + '-' + Format('%4.4d', [i]) + ' = ' + ValeurCaption);
          end;
        ValeurTag := '';
        ValeurHint := '';
        ValeurCaption := '';
        Writeln(FichierLng);
        end;
      end;
    // Lecture du tag
    if Pos('Tag', Ligne) <> 0 then
      begin
      Position := Pos('= ', Ligne);
      ValeurTag := Copy(Ligne, Position + 2, Length(Ligne) - Position);
      while Length(ValeurTag) < 4 do ValeurTag := '0' + ValeurTag;
      end;
    // Lecture du caption
    if Pos('Caption', Ligne) <> 0 then
      begin
      Position := Pos('''', Ligne) + 1;
      if Ligne <> 'Caption =' then
        ValeurCaption := Copy(Ligne, Position, Length(Ligne) - Position)
      else
        begin
        repeat
        Readln(FichierDfm, Ligne);
        ValeurCaption := ValeurCaption + Trim(Ligne);
        until Ligne[Length(Ligne)] <> '+';
        ValeurCaption := StringReplace(ValeurCaption, ' +', '', [rfReplaceAll, rfIgnoreCase]);
        ValeurCaption := StringReplace(ValeurCaption, '''''', '', [rfReplaceAll, rfIgnoreCase]);
        ValeurCaption := Copy(ValeurCaption, 2, Length(ValeurCaption) - 1);
        if ValeurCaption[Length(ValeurCaption)] = '''' then ValeurCaption := Copy(ValeurCaption, 1, Length(ValeurCaption) - 1) else ValeurCaption := ValeurCaption + '''';
        end;
      end;
    // Lecture du hint
    if (Pos('Hint', Ligne) <> 0) and (Pos('ShowHint', Ligne) = 0) and (Pos('ParentShowHint', Ligne) = 0) then
      begin
      Position := Pos('''', Ligne) + 1;
      if Ligne <> 'Hint =' then
        ValeurHint := Copy(Ligne, Position, Length(Ligne) - Position)
      else
        begin
        repeat
        Readln(FichierDfm, Ligne);
        ValeurHint := ValeurHint + Trim(Ligne);
        until Ligne[Length(Ligne)] <> '+';
        ValeurHint := StringReplace(ValeurHint, ' +', '', [rfReplaceAll, rfIgnoreCase]);
        ValeurHint := StringReplace(ValeurHint, '''''', '', [rfReplaceAll, rfIgnoreCase]);
        ValeurHint := Copy(ValeurHint, 2, Length(ValeurHint) - 1);
        if ValeurHint[Length(ValeurHint)] = '''' then ValeurHint := Copy(ValeurHint, 1, Length(ValeurHint) - 1) else ValeurHint := ValeurHint + '''';
        end;
      end;
    // Ecriture de la chaine complte
    if (Pos('object', Ligne) <> 0) or (Ligne = 'end') or (Ligne = 'end>') then
      begin
      if (ValeurTag <> '') and ((ValeurCaption <> '') or (ValeurHint <> '')) then
        begin
        Writeln(FichierLng, '#' + ValeurTag + '-0000 = ' + ValeurCaption);
        if ValeurHint <> '' then Writeln(FichierLng, '#' + ValeurTag + '-0001 = ' + ValeurHint);
        end;
      ValeurTag := '';
      ValeurCaption := '';
      ValeurHint := '';
      end;
    end;
  CloseFile(FichierDfm);
  Writeln(FichierLng); 
  until FindNext(Resultat) <> 0;
  end;

// Traitement des caractres accentus
AssignFile(FichierTmp, 'Language.tmp');
Reset(FichierLng);
Ligne := '';
while not eof(FichierLng) do
  begin
  Readln(FichierLng, Ligne);
  Position := Pos('''', Ligne);
  if Position <> 0 then
    begin
    Code := Copy(Ligne, Position, PosEx('''', Ligne, Position + 1) - Position + 1);
    if (Length(Code) > 2) and (Code[2] = '#') then
      begin
      CopyFile(Pchar(Sortie), Pchar('Language.tmp'), False);
      Reset(FichierTmp);
      Rewrite(FichierLng);
      while not eof(FichierTmp) do
        begin
        Readln(FichierTmp, Ligne);
        if Length(Code) > 6 then
          begin
          CodeTemp := Code;
          while Length(CodeTemp) > 6 do
            begin
            Position := PosEx('#', CodeTemp, 2);
            Valeur := StrToInt(Copy(CodeTemp, 3, Position));
            Ancien := '''#' + IntToStr(Valeur);
            CodeTemp := Copy(CodeTemp, PosEx('#', CodeTemp, Position + 1), Length(CodeTemp));
            Ligne := StringReplace(Ligne, Ancien, chr(Valeur), [rfReplaceAll, rfIgnoreCase]);
            Valeur := StrToInt(Copy(CodeTemp, 2, Length(CodeTemp) - 2));
            Ligne := StringReplace(Ligne, CodeTemp, chr(Valeur), [rfReplaceAll, rfIgnoreCase]);
            Writeln(FichierLng, Ligne);
            end;
          end
        else
          begin
          Valeur := StrToInt(Copy(Code, 3, Length(Code) - 3));
          Ligne := StringReplace(Ligne, Code, chr(Valeur), [rfReplaceAll, rfIgnoreCase]);
          Writeln(FichierLng, Ligne);
          end;
        end;
      CloseFile(FichierTmp);
      Reset(FichierLng);
      end;
    end;
  end;
DeleteFile('Language.tmp');

CloseFile(FichierLng);
CadreChemins.Enabled := True;
BoutonGenerer.Enabled := True;
end;

procedure TPrincipale.FormCreate(Sender: TObject);
var Resultat: TSearchRec;
    i: integer;
    Langue: string;
    n, Len: dword;
    Buf, Version: Pchar;
    S: string;
begin
  // Affichage de la version de l'application
  S := Application.ExeName;
  n := GetFileVersionInfoSize(PChar(S),n);
  Buf := AllocMem(n);
  GetFileVersionInfo(PChar(Application.ExeName), 0, n, Buf);
  VerQueryValue(Buf, PChar('StringFileInfo\040C04E4\FileVersion'), Pointer(Version), Len);
  FreeMem(Buf, n);
  Caption := Caption + ' ' + Version;

  Reg := TRegistry.Create;
  Reg.OpenKey('Software\Edtech\GenLang', True);
  if Reg.ValueExists('Sources') then EditChemin.Text := Reg.ReadString('Sources');
  if Reg.ValueExists('Sortie') then EditSortie.Text := Reg.ReadString('Sortie');
  if not Reg.ValueExists('Language') then Reg.WriteString('Language', 'Franais');
  Langue := Reg.ReadString('Language');
  Reg.CloseKey;
  EdtTranslator.PathFiles := ExtractFilePath(Application.ExeName) + 'Langues';
  EdtTranslator.LanguageFile := Langue + '.lng';
  i := 0;
  if FindFirst(EdtTranslator.PathFiles + '\*.lng', faAnyFile, Resultat) = 0 then
  begin
    repeat
      ListeLangues.AddItem(Copy(Resultat.Name, 1, Length(Resultat.Name) - 4), ListeLangues);
      if ListeLangues.Items.Strings[i] = Langue then ListeLangues.ItemIndex := i;
      inc(i);
    until FindNext(Resultat) <> 0;
  end;
  if Langue <> '' then EdtTranslator.Translate;
  EditNomFichier.Text := Langue;
end;

procedure TPrincipale.BoutonParcourrir1Click(Sender: TObject);
begin
if FileExists(EditChemin.Text) then Parcourir.ArbreDossier.Path := EditChemin.Text;
Parcourir.ShowModal;
if Parcourir.ModalResult = mrOk then EditChemin.Text := Parcourir.ArbreDossier.Path;
end;

procedure TPrincipale.BoutonParcourrir2Click(Sender: TObject);
begin
if FileExists(EditSortie.Text) then Parcourir.ArbreDossier.Path := Editsortie.Text;
Parcourir.ShowModal;
if Parcourir.ModalResult = mrOk then EditSortie.Text := Parcourir.ArbreDossier.Path;

end;

procedure TPrincipale.ListeLanguesChange(Sender: TObject);
begin
EdtTranslator.LanguageFile := ListeLangues.Items.Strings[ListeLangues.ItemIndex] + '.lng';
EdtTranslator.Translate;
EditNomFichier.Text := ListeLangues.Items.Strings[ListeLangues.ItemIndex];
end;

procedure TPrincipale.EditCheminChange(Sender: TObject);
begin
if (Length(EditChemin.Text) = 0) or (Length(EditSortie.Text) = 0) or (Length(EditNomFichier.Text) = 0) then BoutonGenerer.Enabled := False else BoutonGenerer.Enabled := True;
end;

procedure TPrincipale.FormDestroy(Sender: TObject);
begin
Reg.OpenKey('Software\Edtech\GenLang', False);
Reg.WriteString('Language', ListeLangues.Items.Strings[ListeLangues.ItemIndex]);
Reg.WriteString('Sources', EditChemin.Text);
Reg.WriteString('Sortie', EditSortie.Text);
Reg.CloseKey;
Reg.Destroy;
end;

end.
